'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _pearldiver = require('./pearldiver');

var _pearldiver2 = _interopRequireDefault(_pearldiver);

var _curl = require('./curl');

var _curl2 = _interopRequireDefault(_curl);

var _constants = require('./constants');

var Const = _interopRequireWildcard(_constants);

var _converter = require('iota.lib.js/lib/crypto/converter');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var pdInstance = new _pearldiver2.default();

var pow = function pow(options, success, error) {
  var state = void 0;
  if (options.trytes == null) {
    state = pdInstance.offsetState(options.state);
    console.log("offset states");
  } else if (options.state == null) {
    state = pdInstance.prepare(options.trytes);
    console.log("prepared trytes");
  } else {
    error("Error: no trytes or state matrix provided");
  }
  var powPromise = pdInstance.search(state, options.minWeight);
  if (typeof success === 'function') {
    powPromise.then(success).catch(error);
  }
  return powPromise;
};

var overrideAttachToTangle = function overrideAttachToTangle(api) {
  api.attachToTangle = function (trunkTransaction, branchTransaction, minWeight, trytesArray, callback) {
    var _this = this;

    console.log("hey mate");
    var branch = branchTransaction;
    var trunk = trunkTransaction;
    var doWork = function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(txTrytes) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', new Promise(function (resolve, reject) {
                  var trytes = txTrytes.substr(0, txTrytes.length - 81 * 3).concat(trunk).concat(branch);
                  pow({ trytes: trytes, minWeight: minWeight }).then(function (nonce) {
                    resolve(trytes.concat(nonce));
                  });
                }));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }));

      return function doWork(_x) {
        return _ref.apply(this, arguments);
      };
    }();
    _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
      var trytes, curl, hash, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, txTrytes, result, resultTrits;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              trytes = [];
              curl = new _curl2.default();
              hash = new Int32Array(Const.HASH_LENGTH);
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context2.prev = 6;
              _iterator = trytesArray[Symbol.iterator]();

            case 8:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context2.next = 24;
                break;
              }

              txTrytes = _step.value;
              _context2.next = 12;
              return doWork(txTrytes);

            case 12:
              result = _context2.sent;

              console.log('got PoW! ' + result);
              curl.initialize(new Int32Array(Const.STATE_LENGTH));
              resultTrits = (0, _converter.trits)(result);

              curl.absorb(resultTrits, 0, resultTrits.length);
              curl.squeeze(hash, 0, Const.HASH_LENGTH);
              branch = trunk;
              trunk = (0, _converter.trytes)(hash);
              trytes.push(result);

            case 21:
              _iteratorNormalCompletion = true;
              _context2.next = 8;
              break;

            case 24:
              _context2.next = 30;
              break;

            case 26:
              _context2.prev = 26;
              _context2.t0 = _context2['catch'](6);
              _didIteratorError = true;
              _iteratorError = _context2.t0;

            case 30:
              _context2.prev = 30;
              _context2.prev = 31;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 33:
              _context2.prev = 33;

              if (!_didIteratorError) {
                _context2.next = 36;
                break;
              }

              throw _iteratorError;

            case 36:
              return _context2.finish(33);

            case 37:
              return _context2.finish(30);

            case 38:
              callback(null, trytes);

            case 39:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this, [[6, 26, 30, 38], [31,, 33, 37]]);
    }))();
  };
};

exports.default = {
  pow: pow,
  prepare: function prepare(trytes) {
    pdInstance.prepare(trytes);
  },
  setOffset: function setOffset(o) {
    return pdInstance.setOffset(o);
  },
  interrupt: function interrupt() {
    return pdInstance.interrupt();
  },
  resume: function resume() {
    return pdInstance.doNext();
  },
  remove: function remove() {
    return pdInstance.queue.unshift();
  },
  getHashRows: function getHashRows(c) {
    return c(pdInstance.getHashCount());
  },
  overrideAttachToTangle: overrideAttachToTangle
};